// This file was auto-generated by the veyron idl tool.
// Source: fortune.idl

package fortune

import (
	"veyron2/security"

	// The non-user imports are prefixed with "_gen_" to prevent collisions.
	_gen_idl "veyron2/idl"
	_gen_ipc "veyron2/ipc"
	_gen_naming "veyron2/naming"
	_gen_rt "veyron2/rt/r"
	_gen_wiretype "veyron2/wiretype"
)

// Fortune allows clients to Get and Add fortune strings.
// Fortune is the interface the client binds and uses.
// Fortune_InternalNoTagGetter is the interface without the TagGetter
// and UnresolveStep methods (both framework-added, rathern than user-defined),
// to enable embedding without method collisions.  Not to be used directly by
// clients.
type Fortune_InternalNoTagGetter interface {

	// Get returns a random fortune.
	Get(opts ..._gen_ipc.ClientCallOpt) (reply string, err error)

	// Add stores a fortune in the set used by Get.
	Add(Fortune string, opts ..._gen_ipc.ClientCallOpt) (err error)
}
type Fortune interface {
	_gen_idl.TagGetter
	// UnresolveStep returns the names for the remote service, rooted at the
	// service's immediate namespace ancestor.
	UnresolveStep(opts ..._gen_ipc.ClientCallOpt) ([]string, error)
	Fortune_InternalNoTagGetter
}

// FortuneService is the interface the server implements.
type FortuneService interface {

	// Get returns a random fortune.
	Get(context _gen_ipc.Context) (reply string, err error)

	// Add stores a fortune in the set used by Get.
	Add(context _gen_ipc.Context, Fortune string) (err error)
}

// BindFortune returns the client stub implementing the Fortune
// interface.
//
// If no _gen_ipc.Client is specified, the default _gen_ipc.Client in the
// global Runtime is used.
func BindFortune(name string, opts ..._gen_ipc.BindOpt) (Fortune, error) {
	var client _gen_ipc.Client
	switch len(opts) {
	case 0:
		client = _gen_rt.R().Client()
	case 1:
		switch o := opts[0].(type) {
		case _gen_ipc.Runtime:
			client = o.Client()
		case _gen_ipc.Client:
			client = o
		default:
			return nil, _gen_idl.ErrUnrecognizedOption
		}
	default:
		return nil, _gen_idl.ErrTooManyOptionsToBind
	}
	stub := &clientStubFortune{client: client, name: name}

	return stub, nil
}

// NewServerFortune creates a new server stub.
//
// It takes a regular server implementing the FortuneService
// interface, and returns a new server stub.
func NewServerFortune(server FortuneService) interface{} {
	return &ServerStubFortune{
		service: server,
	}
}

// clientStubFortune implements Fortune.
type clientStubFortune struct {
	client _gen_ipc.Client
	name   string
}

func (c *clientStubFortune) GetMethodTags(method string) []interface{} {
	return GetFortuneMethodTags(method)
}

func (__gen_c *clientStubFortune) Get(opts ..._gen_ipc.ClientCallOpt) (reply string, err error) {
	var call _gen_ipc.ClientCall
	if call, err = __gen_c.client.StartCall(__gen_c.name, "Get", nil, opts...); err != nil {
		return
	}
	if ierr := call.Finish(&reply, &err); ierr != nil {
		err = ierr
	}
	return
}

func (__gen_c *clientStubFortune) Add(Fortune string, opts ..._gen_ipc.ClientCallOpt) (err error) {
	var call _gen_ipc.ClientCall
	if call, err = __gen_c.client.StartCall(__gen_c.name, "Add", []interface{}{Fortune}, opts...); err != nil {
		return
	}
	if ierr := call.Finish(&err); ierr != nil {
		err = ierr
	}
	return
}

func (c *clientStubFortune) UnresolveStep(opts ..._gen_ipc.ClientCallOpt) (reply []string, err error) {
	var call _gen_ipc.ClientCall
	if call, err = c.client.StartCall(c.name, "UnresolveStep", nil, opts...); err != nil {
		return
	}
	if ierr := call.Finish(&reply, &err); ierr != nil {
		err = ierr
	}
	return
}

// ServerStubFortune wraps a server that implements
// FortuneService and provides an object that satisfies
// the requirements of veyron2/ipc.ReflectInvoker.
type ServerStubFortune struct {
	service FortuneService
}

func (s *ServerStubFortune) GetMethodTags(method string) []interface{} {
	return GetFortuneMethodTags(method)
}

func (s *ServerStubFortune) Signature(call _gen_ipc.ServerCall) (_gen_ipc.ServiceSignature, error) {
	result := _gen_ipc.ServiceSignature{Methods: make(map[string]_gen_ipc.MethodSignature)}
	result.Methods["Add"] = _gen_ipc.MethodSignature{
		InArgs: []_gen_ipc.MethodArgument{
			{Name: "Fortune", Type: 3},
		},
		OutArgs: []_gen_ipc.MethodArgument{
			{Name: "", Type: 65},
		},
	}
	result.Methods["Get"] = _gen_ipc.MethodSignature{
		InArgs: []_gen_ipc.MethodArgument{},
		OutArgs: []_gen_ipc.MethodArgument{
			{Name: "Fortune", Type: 3},
			{Name: "Err", Type: 65},
		},
	}

	result.TypeDefs = []_gen_idl.AnyData{
		_gen_wiretype.NamedPrimitiveType{Type: 0x1, Name: "error", Tags: []string(nil)}}

	return result, nil
}

func (s *ServerStubFortune) UnresolveStep(call _gen_ipc.ServerCall) (reply []string, err error) {
	if unresolver, ok := s.service.(_gen_ipc.Unresolver); ok {
		return unresolver.UnresolveStep(call)
	}
	if call.Server() == nil {
		return
	}
	var published []string
	if published, err = call.Server().Published(); err != nil || published == nil {
		return
	}
	reply = make([]string, len(published))
	for i, p := range published {
		reply[i] = _gen_naming.Join(p, call.Name())
	}
	return
}

func (__gen_s *ServerStubFortune) Get(call _gen_ipc.ServerCall) (reply string, err error) {
	reply, err = __gen_s.service.Get(call)
	return
}

func (__gen_s *ServerStubFortune) Add(call _gen_ipc.ServerCall, Fortune string) (err error) {
	err = __gen_s.service.Add(call, Fortune)
	return
}

func GetFortuneMethodTags(method string) []interface{} {
	switch method {
	case "Get":
		return []interface{}{security.Label(1)}
	case "Add":
		return []interface{}{security.Label(2)}
	default:
		return nil
	}
}
